//
//  ListTableViewController.m
//  AddLocation
//
//  Created by Greg on 23.10.2013.
//  Copyright (c) 2013 Grzegorz Leszek. All rights reserved.
//

#import "ListTableViewController.h"

#import "AddLocationViewController.h"
#import "AppDelegate.h"
#import "Shop.h"

@interface ListTableViewController ()
{
    NSArray *objList;
}

@end

@implementation ListTableViewController

#pragma mark - Application lifecycle

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemAdd target:self action:@selector(addLocation)];
    
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemAction target:self action:@selector(share)];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    NSFetchRequest* request = [[NSFetchRequest alloc] init];
    request.entity = [NSEntityDescription entityForName: @"Shop"
                                 inManagedObjectContext: [appDelegate managedObjectContext]];
    request.predicate = nil;
    
    NSError* error = nil;
    objList = [[appDelegate managedObjectContext] executeFetchRequest:request error:&error];
    
    [self.tableView reloadData];
}

#pragma mark - Buttons action

-(void)addLocation
{
    AddLocationViewController * alvc = [[AddLocationViewController alloc] init];
    alvc.dataCount = [objList count];
    [self.navigationController pushViewController:alvc animated:YES];
}

-(void)share{
    MFMailComposeViewController *composer=[[MFMailComposeViewController alloc]init];
    [composer setMailComposeDelegate:self];
    if ([MFMailComposeViewController canSendMail]) {
//        [composer setToRecipients:[NSArray arrayWithObjects:@"xyz@gmail.com", nil]];
        [composer setSubject:@"Add Location"];
        
        NSMutableString *body = [NSMutableString string];
        [body appendString:@"name; address; latitude; longitude;\n"];
        for (Shop *aShop in objList) {
            [body appendString:[NSString stringWithFormat:@"%@; %@; %f; %f;\n",aShop.name,aShop.address,[aShop.latitude floatValue],[aShop.longitude floatValue]]];
        }
        
        [composer setMessageBody:body isHTML:NO];
        [composer setModalTransitionStyle:UIModalTransitionStyleCrossDissolve];
        [self presentViewController:composer animated:YES completion:nil];
    }
    else {
    }
}

#pragma mark - Email

-(void)mailComposeController:(MFMailComposeViewController *)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError *)error{
    if (error) {
        UIAlertView *alert=[[UIAlertView alloc]initWithTitle:@"error" message:[NSString stringWithFormat:@"error %@",[error description]] delegate:nil cancelButtonTitle:@"dismiss" otherButtonTitles:nil, nil];
        [alert show];
        [self dismissViewControllerAnimated:YES completion:nil];
    }
    else {
        [self dismissViewControllerAnimated:YES completion:nil];
    }
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [objList count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"MyIdentifier"];
    
    if (cell == nil) {
        
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:@"MyIdentifier"];
        
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        
    }
    
    Shop *aShop = objList[indexPath.row];
    cell.textLabel.text = aShop.name;
    cell.detailTextLabel.text = aShop.address;
    
    return cell;
}


@end
