//
//  Shop.m
//  addlocation
//
//  Created by Greg on 23.10.2013.
//  Copyright (c) 2013 Grzegorz Leszek. All rights reserved.
//

#import "Shop.h"


@implementation Shop

@dynamic name;
@dynamic address;
@dynamic latitude;
@dynamic longitude;
@dynamic uniqueid;

+(Shop*) shopWithName: (NSString*) name
              address: (NSString*) address
             latitude: (float) latitude
            longitude: (float) longitude
             uniqueid: (int) uniqueid
inManagedObjectContext:(NSManagedObjectContext*) context
{
    Shop *aShop = nil;
    NSFetchRequest* request = [[NSFetchRequest alloc] init];
    request.entity = [NSEntityDescription entityForName: @"Shop"
                                 inManagedObjectContext: context];
    request.predicate = [NSPredicate predicateWithFormat:@"uniqueid == %d",uniqueid ];
    
    NSError* error = nil;
    aShop = [[context executeFetchRequest:request error:&error] lastObject];
    
    if (!error && !aShop) {
        aShop = [NSEntityDescription insertNewObjectForEntityForName:@"Shop" inManagedObjectContext:context];
        aShop.name = name;
        aShop.address = address;
        aShop.latitude = [NSNumber numberWithFloat:latitude];
        aShop.longitude = [NSNumber numberWithFloat:longitude];
        aShop.uniqueid = [NSNumber numberWithFloat:uniqueid];
    }
    return aShop;
}

@end
